{/*
   UPuissance4Globals.pas

   DATE   : 08/01/2007
   NOTE   : Cette unit englobe toutes les variables du programme
   AUTEUR : KHELIL RADOUANE ABDESSALAM
   EMAIL  : rkhelil@gmail.com
*/}

UNIT UPuissance4Globals;

INTERFACE
Const
  // Plateau de 7 colonnes et 6 lignes
  MAX_COL = 7;
  MAX_LIN = 6;

  // Une cellule est un rectangle de 40 x 34 pixels
  DIM_X = 40;
  DIM_Y = 34;

Type
  // Etat d'une cllule du plateau.
  Str25 = String[25];
  TCellState  = ( csEmpty , csWhite , csBlack );
  THitMemory = Array[1..MAX_COL*MAX_LIN] Of Byte;
Var
  // Plateau du jeu
  aGame  : Array[1..MAX_COL,1..MAX_LIN] Of TCellState;

  // Pour sauvegarder les coups jous donc les colonnes joues (facile non !!!)
  aStack    : THitMemory;
  nStackPtr : Integer;

  // Pointeur sur chaque colonne pour determiner o sera placer le prochain jeton
  aCurPtr : Array[1..MAX_COL] Of Byte;

  // Joueur courant (0 = White) (1 = Black)
  nCurPlayer : Byte;

  // Noms des 2 joueurs
  cPlayer1,cPlayer2 : Str25;

  // Nombre de jetons de chaque joueur
  nBalls1,nBalls2 : Integer;
  nMaxMoves       : Integer;

  // La diffrence entre la dimension de la fentre et la zone de dessin
  // PaintBox
  DELTA_X,DELTA_Y : Integer;
  // Colonne en cours de slection
  nSelectedColumn : Integer;

  // Indique si on doit redessiner l'ensemble du plateau ou non.
  REDRAW_ALL : Boolean;

      Function  Max( nVal1 , nVal2 : Integer ):Integer;

IMPLEMENTATION

{/*
   Retourne la valeur Max de 2 nombres.
*/}
Function Max( nVal1 , nVal2 : Integer ):Integer;
Begin
  IF ( nVal1 >= nVal2 ) Then Result := nVal1
                        Else Result := nVal2;
End;

{/*
  Initialisation des variables
*/}
BEGIN
  cPlayer1   := 'Joueur 1';
  cPlayer2   := 'Joueur 2';
  REDRAW_ALL := FALSE;
END.
