{/*
   UPuissance4RWFile.pas

   DATE   : 08/01/2007
   NOTE   : Cette unit gre la sauvegarde et la restauration d'une partie dans un fichier.
   AUTEUR : KHELIL RADOUANE ABDESSALAM
   EMAIL  : rkhelil@gmail.com
*/}
UNIT UPuissance4RWFile;

INTERFACE

Uses UPuissance4Globals;

    Procedure SaveGameToFile( cFileName : String );
    Procedure LoadGameFromFile( cFileName : String );

IMPLEMENTATION
Uses UPuissance4GameProcess;

Type
    TGameInfos = Record
                   Hits    : THitMemory;
                   cPName1 : Str25;
                   cPName2 : Str25;
                 End;

{/*
   Sauvegarde la partie en cours dans un fichier
*/}
Procedure SaveGameToFile( cFileName : String  );
Var
  F  : File Of TGameInfos;
  GI : TGameInfos;
Begin
  // Rcuperation des coups ainsi que les noms des joueurs
  GI.Hits    := aStack;
  GI.cPName1 := cPlayer1;
  GI.cPName2 := cPlayer2;

  // Enregistrement le fichier
  Assign( F , cFileName );
  Rewrite( F );
  Write( F , GI );
  Close( F );
End;

{/*
   Charge une partie  partir d'un fichier.
*/}
Procedure LoadGameFromFile( cFileName  : String );
Var
  F  : File Of TGameInfos;
  GI : TGameInfos;
  I  : Integer;
Begin
  // Lecture des donnes du fichier
  Assign( F , cFileName );
  Reset( F );
  Read( F , GI );
  Close( F );

  // Jouer les coups
  InitGame;
  cPlayer1 := GI.cPName1;
  cPlayer2 := GI.cPName2;

  For I:=1 To MAX_COL*MAX_LIN Do
  Begin
    IF (GI.Hits[I] <> 0) Then
    Begin
      nSelectedColumn := GI.Hits[I]; // Quelle colonne a t joue
      Play(TRUE);                    // On l'a joue
    End;
  End;
End;

END.
